/*
 *
 *       Density module for HP_DeskJet_870C
 *
 *       Includes the new 600 dpi resolution.
 */

#include "global.h"


#define DENSITY 15

extern struct PrinterData *PD;
extern struct PrinterExtendedData *PED;
extern char StartCmd[];

void SetDensity(ULONG density_code)
{
        /* SPECIAL_DENSITY     0   1   2    3    4    5    6    7 */
        static int XDPI[8] = {150, 150, 150, 300, 300, 600, 600, 600};
        static char codes[8][3] = {
        {'1','5','0'},{'2','5','0'},{'1','5','0'},{'3','0','0'},
        {'3','0','0'},{'6','0','0'},{'6','0','0'},{'6','0','0'},
        };
        density_code /= SPECIAL_DENSITY1;
        PED->ped_MaxXDots = XDPI[density_code] * 8;

        /* David Berezowski - April 22/90 */
        /* default is 10.0, US_LEGAL is 14.0 */
        PED->ped_MaxYDots =
                PD->pd_Preferences.PaperSize == US_LEGAL ? 14 : 10;
        PED->ped_MaxYDots *= XDPI[density_code];

        PED->ped_XDotsInch = PED->ped_YDotsInch = XDPI[density_code];
        
        /* Density 5 = 600 x 300 */
        if (density_code == 5) {
            PED->ped_YDotsInch = 300;
            PED->ped_MaxYDots /= 2;
        }
        StartCmd[DENSITY]   = codes[density_code][0];
        StartCmd[DENSITY+1] = codes[density_code][1];
        StartCmd[DENSITY+2] = codes[density_code][2];
}
